/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function AutoScrollWidget(sId, sWidgetDomId)
{
  if (sId) { this.init(sId, sWidgetDomId); }
}
var staticAutoScrollWidget = new Array;
AutoScrollWidget_getInstance = function(sId)
{
  var Instance = null;
  if ( staticAutoScrollWidget[sId] )
  {
    Instance = staticAutoScrollWidget[sId];
  }
  return Instance;
}
AutoScrollWidget.prototype.init = function(sId, sWidgetDomId)
{
  ;
  this.sId = sId;
  this.sWidgetDomId = sWidgetDomId;
  this.oWidget = Browser.getElementById(sWidgetDomId);
  if ( ! this.oWidget )
  {
    ;
  }
  this.oWidget.scrollTop = '0px';
  this.nScrollStep = 1;
  this.nScrollInterval = 30;
  this.endScrollAction = null;
  staticAutoScrollWidget[sId] = this;
}
AutoScrollWidget.prototype.getId = function()
{
  return this.sId;
}
AutoScrollWidget.prototype.setScrollStep = function(nScrollStep)
{
  this.nScrollStep= nScrollStep;
}
AutoScrollWidget.prototype.setScrollInterval = function(nScrollInterval)
{
  this.nScrollInterval = nScrollInterval;
}
AutoScrollWidget.prototype.setEndScrollAction = function(endScrollAction)
{
  this.endScrollAction = endScrollAction;
}
AutoScrollWidget.prototype.startScroll = function()
{
  ;
  if (this.scrollTimer != null) window.clearInterval(this.scrollTimer);
  this.scrollTimer = window.setInterval('AutoScrollWidget_getInstance(\''+this.sId+'\').scrollStep();', this.nScrollInterval);
}
AutoScrollWidget.prototype.stopScroll = function()
{
  ;
  if (this.scrollTimer != null) window.clearInterval(this.scrollTimer);
  if ( this.endScrollAction )
  {
    this.endScrollAction.invoke();
  }
}
AutoScrollWidget.prototype.scrollStep = function()
{
  //;
  this.oWidget.scrollTop += this.nScrollStep;    
  if ( this.oWidget.scrollTop + this.oWidget.clientHeight >= this.oWidget.scrollHeight )
  {
    window.clearInterval(this.scrollTimer);
    if ( this.endScrollAction )
    {
      this.endScrollAction.invoke();
    }
  }
}
AutoScrollWidget.prototype.getStartScrollAction = function()
{
    return new ObjectMethodAction(this, "startScroll");
}
