/*
<DEPENDENCIES>
</DEPENDENCIES>
*/
function SimpleForm(sId, sDomId)
{
  this.sId = sId;
  this.sDomId = sDomId;
  this.submitted = false;
}
SimpleForm.prototype.setOnSubmitHandle = function(onSubmitAction)
{
  var eventHandler = function(event)
  {
    if (!event)
    {
      event = window.event;     
    }
    var flag = onSubmitAction.invoke()
    if (!flag || this.submitted)
    {
      Browser.eventStopPropagation(event)
      Browser.eventPreventDefault(event)
    }
    else
    {
      this.submitted = true;
    }
  }
  Browser.addEventListener(this.sDomId, Browser.eventNames.SUBMIT, eventHandler);
}
SimpleForm.prototype.getSubmitAction = function()
{
    return new ObjectMethodAction(this, "submit");
}
SimpleForm.prototype.submit = function()
{
    var element = Browser.getElementById(this.sDomId);
    element.submit();
}
