/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Controller</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
</DEPENDENCIES>
*/
KeyEventListener.prototype             = new DomletCtr();
KeyEventListener.prototype.constructor = KeyEventListener;
KeyEventListener.superclass            = DomletCtr.prototype;
function KeyEventListener(sId, sInputWidgetDomId)
{
  if (sId) { this.init(sId, sInputWidgetDomId); }
}
KeyEventListener.prototype.init = function(sId, sInputWidgetDomId)
{
  ;   
  this.sId = sId;
  this.selection = null;
  this.oKeyboardBroker = null;
  this.bHasFocus = false;
  this.bDoBlurAfterUpdate = true;
  KeyEventListener.superclass.init.call(this, this.sInputWidgetDomId, this.sId, this);
  this.inputWidget = document.getElementById(sInputWidgetDomId);
  this.sInputWidgetDomId = sInputWidgetDomId;
  if (this.inputWidget == null)
  {
      ;
  }
  else
  {
    this.addDomlet(new Domlet(
      this.sInputWidgetDomId,      
      this.sInputWidgetDomId,      
      this,                        
    new Array('focus')))     
    var me = this;
    this.beforepasteCallback = function()
    {
      ;
      if (document && document.readyState == 'complete' && document.activeElement && document.activeElement == me.inputWidget)
      {
        var sel = document.selection.createRange();
        var saveSel = sel.duplicate();
        var length = 0;
        var nCursor = 0;
        if ( me.inputWidget.value )
        {
          length =  sel.text.length;
          var tmpSel = sel.duplicate();
          var saveSel = sel.duplicate();
          for (var i = 0; sel.htmlText.charAt(0) != '<'; i++)
          {
            if (!sel.moveStart('character', -1))
            {
                return;
             }
          }
          ;
          tmpSel.collapse(false);
          tmpSel.text = 'n';
          tmpSel = sel.duplicate();
          tmpSel.moveEnd('character', 1);
          ;
          var sTempString = tmpSel.text;
          for( var nChar = 0; nChar <sTempString.length; nChar++)
          {
            if ( sTempString.charAt(nChar) != '\n' )
            {
              nCursor++;
            }
          }
          if ( nCursor ) { nCursor--; }
          tmpSel.collapse(false);
          tmpSel.moveStart('character', -1);
          tmpSel.text = '';
          saveSel.select();
        }
        me.inputWidget.selectionStart = nCursor;
        me.inputWidget.selectionEnd = nCursor + length;
        ;
      }
    }
    Browser.addEventListenerToDocument(Browser.eventNames.SELECTIONCHANGE, this.beforepasteCallback);
    Browser.addEventListenerToDomNode(this.inputWidget, Browser.eventNames.CHANGE, this.beforepasteCallback);
  }
}
KeyEventListener.prototype.getId = function()
{
  ////;
  return this.sId;
}
KeyEventListener.prototype.setKeyboardBroker = function(broker)
{
  ////;
  this.oKeyboardBroker = broker;
}
KeyEventListener.prototype.eventFromChild = function(childName, eventType, event)
{
  ////;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "focus" :
      ;
      this.focusHandler(domlet, event);
      break;
  }
}
KeyEventListener.prototype.focusHandler = function(domlet, event)
{
  ;
  if (this.oKeyboardBroker )
  {
    this.oKeyboardBroker.doGotFocus(this.sId);
  }
  else
  {
    ;
  }
}
KeyEventListener.prototype.addChar = function(sChar)
{
  if ( this.bHasFocus )
  {
    this.inputWidget.focus();
    var nSelectionStart = this.inputWidget.selectionStart;
    var nSelectionEnd = this.inputWidget.selectionEnd;
    var sCurrentText = this.inputWidget.innerText;
   ;
    var sText = '';
    var sNewSelection = null;
    if ( nSelectionStart != undefined )
    {
      sText = sCurrentText.substr(0,nSelectionStart);
      sText += sChar;
      sNewSelection = sText.length;
      sText += sCurrentText.substr(nSelectionEnd, sCurrentText.length);
    }
    else
    {
      sText = sChar;
      sNewSelection = sText.length;
    }
    this.inputWidget.innerText = sText;
    this.inputWidget.selectionStart = sNewSelection;
    this.inputWidget.selectionEnd = sNewSelection;
  }
}
KeyEventListener.prototype.gotFocus = function(sFocusElementId)
{
  ;
  if( sFocusElementId == this.sId )
  {
    this.bHasFocus = true;
  }
  else
  {
    this.bHasFocus = false;
  }
}
KeyEventListener.prototype.getGotFocusAction = function()
{
    return new ObjectMethodAction(this, "gotFocus");
}
KeyEventListener.prototype.getAddCharAction = function(sChar)
{
    return new ObjectMethodAction(this, "addChar", sChar);
}
