/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>QeaAdapter</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
</DEPENDENCIES>
*/
BingoTile.prototype             = new QeaAdapter();
BingoTile.prototype.constructor = BingoTile;
BingoTile.superclass            = QeaAdapter.prototype;
function BingoTile(sId, sWidgetDomId)
{
  if (sId) { this.init(sId, sWidgetDomId); }
}
BingoTile.prototype.init = function(sId, sWidgetDomId)
{
  ;
  BingoTile.superclass.init.call(this, sId, sWidgetDomId);
  this.bingoManager = null;
  this.widget = document.getElementById(sWidgetDomId);
  if (this.widget == null)
  {
    ;
  }
  this.addDomlet(new Domlet(
    this.sWidgetDomId,      
    this.sWidgetDomId,      
    this,                   
    new Array('click')) 
  )
}
BingoTile.prototype.setManager = function(bingoManager)
{
  ;
  this.bingoManager = bingoManager;
}
BingoTile.prototype.eventFromChild = function(childName, eventType, event)
{
  //;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "click" :
      ;
      this.clickHandler(domlet, event);
      break;
  }
}
BingoTile.prototype.clickHandler = function(domlet, event)
{
  ;
  this.bingoManager.clickTile(this);
}
BingoTile.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    this.bIgnored = true;
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      this.bIgnored = true;
      if (this.broker) { this.broker.showUnassigned(); }                       
    }    
    else if (nCount == 1)
    {
      if (model.getEvaluation().isCorrect())
      {
        if (this.broker) { this.broker.showCorrect(); }
      }
      else
      {
        if (this.broker) { this.broker.showWrong(); }
      }
    }
  }
}
