/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
</DEPENDENCIES>
*/
PlaylistBroker.prototype             = new Broker();
PlaylistBroker.prototype.constructor = PlaylistBroker;
PlaylistBroker.superclass            = Broker.prototype;
function PlaylistBroker()
{
 	PlaylistBroker.superclass.init.call(this, "PlaylistBroker");
}
PlaylistBroker.prototype.doPlaylistStarted = function()
{
    ;
    this.getMessage("playlistStarted");
}
PlaylistBroker.prototype.addPlaylistStartedHandle = function(action)
{
	this.registerAction("playlistStarted", action);
}
PlaylistBroker.prototype.getPlaylistStartedAction = function()
{
	;
	return new ObjectMethodAction(this, "playlistStarted");
}
PlaylistBroker.prototype.playlistStarted = function()
{
	;
	this.doPlaylistStarted();
}
PlaylistBroker.prototype.doPlaylistStopped = function()
{
	;
	this.getMessage("playlistStopped");
}
PlaylistBroker.prototype.addPlaylistStoppedHandle = function(action)
{
	this.registerAction("playlistStopped", action);
}
PlaylistBroker.prototype.getPlaylistStoppedAction = function()
{
	return new ObjectMethodAction(this, "playlistStopped");
}
PlaylistBroker.prototype.playlistStopped = function()
{
	this.doSoundStopped();
}
PlaylistBroker.prototype.doRequestPlaylistStart = function()
{
	;
	this.getMessage("requestPlaylistStart");
}
PlaylistBroker.prototype.addRequestPlaylistStartHandle = function(action)
{
	;
	this.registerAction("requestPlaylistStart", action);
}
PlaylistBroker.prototype.getRequestPlaylistStartAction = function()
{
	;
	return new ObjectMethodAction(this, "requestPlaylistStart");
}
PlaylistBroker.prototype.requestPlaylistStart = function()
{
	;
	this.doRequestPlaylistStart();
}
PlaylistBroker.prototype.doRequestPlaylistStop = function()
{
	;
	this.getMessage("requestPlaylistStop");
}
PlaylistBroker.prototype.addRequestPlaylistStopHandle = function(action)
{
	;
	this.registerAction("requestPlaylistStop", action);
}
PlaylistBroker.prototype.getRequestPlaylistStopAction = function()
{
	;
	return new ObjectMethodAction(this, "requestPlaylistStop");
}
PlaylistBroker.prototype.requestPlaylistStop = function()
{
	;
	this.doRequestPlaylistStop();
}
