/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function PositionAdjusterManager(sId, bAlwaysMove, sContainerDomId)
{ 
  ;
  this.sId = sId;
  this.elements = new Array();
  this.sizeAdjusters = new Array();
  this.aPositionStrategys = new Array();
  this.bAlwaysMove = bAlwaysMove;
  if(sContainerDomId)
  {
      this.sContainerDomId = sContainerDomId;
      this.oContainer =  document.getElementById(sContainerDomId);
      if ( ! this.oContainer )
      {
        ;
      }
  }
  if(this.oContainer)
  {
     this.adjustmentPoint = new Point(0,0);
     Browser.getLocation(this.oContainer,this.adjustmentPoint);
  }
}
PositionAdjusterManager.prototype.addElement = function(element)
{
    this.elements[this.elements.length] = element;
}
PositionAdjusterManager.prototype.registerSizeAdjuster = function(sizeAdjuster)
{
    this.sizeAdjusters.push(sizeAdjuster);
}
PositionAdjusterManager.prototype.start = function()
{
    ;
    ;
    for (var i = 0; i < this.sizeAdjusters.length; i++)
    {
      this.sizeAdjusters[i].start();
    }  
    ;
    for (var i = 0; i < this.elements.length; i++)
    {
        aktElement = this.elements[i];
        ;
        var dropWidget = Browser.getElementById(aktElement);
        var pOrigPos = new Point(0,0);
        var pOrigLeft = Browser.getPixelStyle(dropWidget, 'left');
        var pOrigTop = Browser.getPixelStyle(dropWidget, 'top');
        var pOrigWidth =  dropWidget.offsetWidth;
        var pOrigHeight =  dropWidget.offsetHeight;
        Browser.getLocation(dropWidget, pOrigPos);
         dropWidget.style.position = 'absolute';
          Browser.changePixelStyle(dropWidget, "width", pOrigWidth);
          Browser.changePixelStyle(dropWidget, "height", pOrigHeight);
        var sOrigPosInd = dropWidget.style.position;
        var doesFit = false;
        doesFit = this.doesFit(pOrigPos, pOrigWidth, pOrigHeight);
        if ( !doesFit )
        {
          for ( var j = 0; j < this.aPositionStrategys.length; j++)
          {
            Browser.moveToLocation(dropWidget, pOrigPos);
            Browser.changePixelStyle(dropWidget, 'top', parseInt(dropWidget.style.top) + this.aPositionStrategys[j].yOffset);
            if ( this.aPositionStrategys[j].sAlign == 'r' )
            {
              Browser.changePixelStyle(dropWidget, 'left', parseInt(dropWidget.style.left) - pOrigWidth);
            }
            if ( this.aPositionStrategys[j].sAlign == 'c' )
            {
              Browser.changePixelStyle(dropWidget, 'left', parseInt(dropWidget.style.left) - parseInt(pOrigWidth/2));
            }
            Browser.changePixelStyle(dropWidget, 'left', parseInt(dropWidget.style.left) + this.aPositionStrategys[j].xOffset);
            pOrigPos = new Point(0,0);
            Browser.getLocation(dropWidget, pOrigPos);
            if ( this.doesFit(pOrigPos, pOrigWidth, pOrigHeight) )
            {
              doesFit = true;
              break;
            }
          }
        }
        if ( ! doesFit )
        {
          dropWidget.style.position = sOrigPosInd;
          Browser.changePixelStyle(dropWidget, 'left', pOrigLeft);
          Browser.changePixelStyle(dropWidget, 'top', pOrigTop);
        }
    }
}
PositionAdjusterManager.prototype.registerPositionStrategy = function(xOffset, yOffset, sAlign)
{
    function PositionStrategy(xOffset, yOffset, sAlign)
    {
      this.xOffset = xOffset;
      this.yOffset = yOffset;
      this.sAlign = sAlign;
    }
    this.aPositionStrategys.push(new PositionStrategy(xOffset, yOffset, sAlign));
}
PositionAdjusterManager.prototype.doesFit = function(dropLocation, width, height)
{
  var bFit = true;
  if(!this.adjustmentPoint)
  {
    ;
    return bFit;
  }
  var maxWidth = null;
  var maxHeight = null;
  var widgetWidth = null;
  var widgetHeight = null;
  if ( bFit )
  {
    if ( dropLocation.x < this.adjustmentPoint.x )
    {
      bFit = false;
    }
  }
  if ( bFit )
  {
    if ( dropLocation.y < this.adjustmentPoint.y )
    {
      bFit = false;
    }
  }
  if ( bFit )
  {
    var maxWidth = parseInt(this.oContainer.offsetWidth);
    var maxHeight = parseInt(this.oContainer.offsetHeight);
    var widgetWidth = width;
    var widgetHeight = height;
    ;
  }
  if ( bFit )
  {
    if ( (dropLocation.x + widgetWidth) > (this.adjustmentPoint.x + maxWidth ) )
    {
      bFit = false;
    }
  }
  if ( bFit )
  {
    if ( (dropLocation.y + widgetHeight) > (this.adjustmentPoint.y + maxHeight))
    {
      bFit = false;
    }
  }
  ;
  return bFit;
}
