/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>HandleMap</DEPENDS>
</DEPENDENCIES>
*/
function LiveConnectEventSender(senderApplet) {
    this.senderApplet = senderApplet;
    this.sendBuffer = new Array();
    HandleMap.instance.setSender(this);
}
LiveConnectEventSender.prototype.send = function (handleName, methodName, args) {
    var handleMap_ = eval('document.' + this.senderApplet +'.getHandleMap()');
    if (handleMap_ == null) {
        alert("java handle map not found"); }
    var handle = handleMap_.getHandle(handleName);
    if (handle == null) {
        if (this.sendBuffer[handleName] == null) {
            this.sendBuffer[handleName] = new Array();
            this.sendBuffer[handleName]["counter"] = 0;
        }
        counter = this.sendBuffer[handleName]["counter"];
        var tmp = new Array();
        tmp["handleName"] = handleName;
        tmp["methodName"] = methodName;
        tmp["args"] = args;
        if(this.sendBuffer[handleName]["data"] == null)
        {
            this.sendBuffer[handleName]["data"] = new Array();
        }
        this.sendBuffer[handleName]["data"][counter] = tmp;
        this.sendBuffer[handleName]["counter"] = counter + 1;
    } else {
        this.doSend(handle, methodName, args);
    }
}
LiveConnectEventSender.prototype.doSend = function (handle, methodName, args) {
    var execString = "handle[methodName](";
    if (args.length > 0) {
        execString += "args[0]";
    }
    for (var i = 1; i < args.length; i++) {
        execString += ", ";
        execString += "args[" + i  + "]";
    }
    execString += ");";
    if(handle == null){
        alert("handle for name '" + handlename + "' is null. Cannot execute '"
        + execString + "' with handle='" + handlename
        + "' and methodname='" + methodName + "'"); }
    eval(execString);
}
LiveConnectEventSender.prototype.handleRegistered = function (handleName) {
    var handleMap_ = eval('document.' + this.senderApplet +'.getHandleMap()');
    if (handleMap_ == null) {
        alert("java handle map not found"); }
    var handle = handleMap_.getHandle(handleName);
    if (this.sendBuffer[handleName] != null) {
        var counter = this.sendBuffer[handleName]["counter"];
        for (var i = 0; i < counter; i++) {
            var tmp = this.sendBuffer[handleName]["data"][i];
            handleName = tmp["handleName"];
            methodName = tmp["methodName"];
            args = tmp["args"];
            this.doSend(handle, methodName, args);
        }
        this.sendBuffer[handleName] = null;
    }
}
