/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function KeyboardAdapter(sId)
{
  if (sId) { this.init(sId); }
}
KeyboardAdapter.prototype.init = function(sId)
{
  ;   
  this.sId = sId;
  this.receivedCharAction = null;
}
KeyboardAdapter.prototype.start = function()
{
  eventKeypress = function(event)
  {
    if (! event )
    {
      var event = window.event;
    }
    me.keypressHandler(event);
  }
  var me = this;
  Browser.addEventListenerToDocument(Browser.eventNames.KEYPRESS, eventKeypress);
}
KeyboardAdapter.prototype.getId = function()
{
  //;
  return this.sId;
}
KeyboardAdapter.prototype.setReceivedCharAction = function(receivedCharAction)
{
  ;
  this.receivedCharAction = receivedCharAction;
}
KeyboardAdapter.prototype.keypressHandler = function(event)
{
  ;
  var sChar = null;
  if ( event.isChar )
  {
    event.preventDefault();
    event.stopPropagation();
    sChar = String.fromCharCode(event.which);
    if ( this.receivedCharAction )
    {
      this.receivedCharAction.invoke(sChar);
    }
  }
  return false;
}
