/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
ClickwatcherBroker.prototype = new Broker();
ClickwatcherBroker.prototype.constructor = ClickwatcherBroker;
ClickwatcherBroker.superclass = Broker.prototype;
function ClickwatcherBroker(sId)
{
	this.init(sId);
}
ClickwatcherBroker.prototype.init = function(sId)
{
	this.sId = sId;
	ClickwatcherBroker.superclass.init.call(this, sId);
}
ClickwatcherBroker.prototype.getId = function()
{
	return this.sId;
}
ClickwatcherBroker.prototype.getSetBrowseModeAction = function()
{
	return new ObjectMethodAction(this, "browse");
}
ClickwatcherBroker.prototype.browse = function()
{
	this.getMessage("browse");
}
ClickwatcherBroker.prototype.addBrowseModeHandle = function(action)
{
	this.registerAction("browse", action);
}
ClickwatcherBroker.prototype.addBrowseModeSetHandle = function(action)
{
	this.registerAction("browseset", action);
}
ClickwatcherBroker.prototype.doBrowseModeSet = function()
{
	this.getMessage("browseset");
}
ClickwatcherBroker.prototype.getSetAnaylseModeAction = function()
{
	return new ObjectMethodAction(this, "analyse");
}
ClickwatcherBroker.prototype.analyse = function()
{
	this.getMessage("analyse");
}
ClickwatcherBroker.prototype.addAnaylseModeHandle = function(action)
{
	this.registerAction("analyse", action);
}
ClickwatcherBroker.prototype.addAnaylseModeSetHandle = function(action)
{
	this.registerAction("analyseset", action);
}
ClickwatcherBroker.prototype.doAnaylseModeSet = function()
{
	this.getMessage("analyseset");
}
ClickwatcherBroker.prototype.addLoadPageStartedHandle = function(action)
{
	this.registerAction("loadPageStarted", action);
}
ClickwatcherBroker.prototype.doLoadPageStarted = function(action)
{
	this.getMessage("loadPageStarted");
}
ClickwatcherBroker.prototype.addLoadPageFinishedHandle = function(action)
{
	this.registerAction("loadPageFinished", action);
}
ClickwatcherBroker.prototype.doLoadPageFinished = function(action)
{
	this.getMessage("loadPageFinished");
}
ClickwatcherBroker.prototype.addLoadPageErrorHandle = function(action)
{
	this.registerAction("loadPageError", action);
}
ClickwatcherBroker.prototype.doLoadPageError = function()
{
	this.getMessage("loadPageError");
}
ClickwatcherBroker.prototype.addLoadDataStartedHandle = function(action)
{
	this.registerAction("loadDataStarted", action);
}
ClickwatcherBroker.prototype.doLoadDataStarted = function(action)
{
	this.getMessage("loadDataStarted");
}
ClickwatcherBroker.prototype.addLoadDataFinishedHandle = function(action)
{
	this.registerAction("loadDataFinished", action);
}
ClickwatcherBroker.prototype.doLoadDataFinished = function(action)
{
	this.getMessage("loadDataFinished");
}
ClickwatcherBroker.prototype.getBrowseLastValidAction = function()
{
	return new ObjectMethodAction(this, "browseLastValid");
}
ClickwatcherBroker.prototype.addBrowseLastValidHandle = function(action)
{
	this.registerAction("browseLastValid", action);
}
ClickwatcherBroker.prototype.browseLastValid = function()
{
 	this.getMessage("browseLastValid");
}
ClickwatcherBroker.prototype.getApplyActiveModeAction = function()
{
	return new ObjectMethodAction(this, "doApplyActiveMode");
}
ClickwatcherBroker.prototype.addApplyActiveModeHandle = function(action)
{
	this.registerAction("applyActiveMode", action);
}
ClickwatcherBroker.prototype.doApplyActiveMode = function()
{
 	this.getMessage("applyActiveMode");
}
ClickwatcherBroker.prototype.getResetAction = function()
{
	return new ObjectMethodAction(this, "doReset");
}
ClickwatcherBroker.prototype.addResetHandle = function(action)
{
	this.registerAction("reset", action);
}
ClickwatcherBroker.prototype.doReset = function()
{
 	this.getMessage("reset");
}
