/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
</DEPENDENCIES>
*/
MovieBroker.prototype             = new Broker();
MovieBroker.prototype.constructor = MovieBroker;
MovieBroker.superclass            = Broker.prototype;
function MovieBroker()
{
	;
	this.movieController = null;
 	MovieBroker.superclass.init.call(this, "MovieBroker");
}
MovieBroker.prototype.setMovieController = function(movieController)
{
	this.movieController = movieController;
}
MovieBroker.prototype.doMovieStarted = function()
{
    ;
    this.getMessage("movieStarted");
}
MovieBroker.prototype.addMovieStartedHandle = function(action)
{
	this.registerAction("movieStarted", action);
}
MovieBroker.prototype.getMovieStartedAction = function()
{
	return new ObjectMethodAction(this, "movieStarted");
}
MovieBroker.prototype.movieStarted = function()
{
	if (this.tipController)
		this.tipController.shouldMovieStarted();
	else
		this.doMovieStarted();
}
MovieBroker.prototype.doMovieStopped = function()
{
	;
	this.getMessage("movieStopped");
}
MovieBroker.prototype.addMovieStoppedHandle = function(action)
{
	this.registerAction("movieStopped", action);
}
MovieBroker.prototype.getMovieStoppedAction = function()
{
	return new ObjectMethodAction(this, "movieStopped");
}
MovieBroker.prototype.movieStopped = function()
{
	if (this.tipController)
		this.tipController.shouldMovieStopped();
	else
		this.doMovieStopped();
}
MovieBroker.prototype.doMoviePaused = function()
{
	this.getMessage("moviePaused");
}
MovieBroker.prototype.addMoviePausedHandle = function(action)
{
	this.registerAction("moviePaused", action);
}
MovieBroker.prototype.getMoviePausedAction = function()
{
	return new ObjectMethodAction(this, "moviePaused");
}
MovieBroker.prototype.moviePaused = function()
{
	if (this.tipController)
		this.tipController.shouldMoviePaused();
	else
		this.doMoviePaused();
}
MovieBroker.prototype.doRequestMovieStart = function()
{
	this.getMessage("requestMovieStart");
}
MovieBroker.prototype.addRequestMovieStartHandle = function(action)
{
	this.registerAction("requestMovieStart", action);
}
MovieBroker.prototype.getRequestMovieStartAction = function()
{
	return new ObjectMethodAction(this, "requestMovieStart");
}
MovieBroker.prototype.requestMovieStart = function()
{
	if (this.tipController)
		this.tipController.shouldRequestMovieStart();
	else
		this.doRequestMovieStart();
}
MovieBroker.prototype.doRequestMovieStop = function()
{
	this.getMessage("requestMovieStop");
}
MovieBroker.prototype.addRequestMovieStopHandle = function(action)
{
	this.registerAction("requestMovieStop", action);
}
MovieBroker.prototype.getRequestMovieStopAction = function()
{
	return new ObjectMethodAction(this, "requestMovieStop");
}
MovieBroker.prototype.requestMovieStop = function()
{
	if (this.tipController)
		this.tipController.shouldRequestMovieStop();
	else
		this.doRequestMovieStop();
}
MovieBroker.prototype.doRequestMoviePause = function()
{
	this.getMessage("requestMoviePause");
}
MovieBroker.prototype.addRequestMoviePauseHandle = function(action)
{
	this.registerAction("requestMoviePause", action);
}
MovieBroker.prototype.getRequestMoviePauseAction = function()
{
	return new ObjectMethodAction(this, "requestMoviePause");
}
MovieBroker.prototype.requestMoviePause = function()
{
	if (this.tipController)
		this.tipController.shouldRequestMoviePause();
	else
		this.doRequestMoviePause();
}
MovieBroker.prototype.doPercentageIntervalReached = function(percentage)
{
    if (percentage == undefined)
	    this.getMessage("percentageIntervalReached");
	else
	{
	    var percentageArray = new Array();
	    percentageArray[0] = percentage;
	    this.getMessage("percentageIntervalReached", percentageArray);
	}
}
MovieBroker.prototype.addPercentageIntervalReachedHandle = function(action)
{
	this.registerAction("percentageIntervalReached", action);
}
MovieBroker.prototype.getPercentageIntervalReachedAction = function(percentage)
{
	return new ObjectMethodAction(this, "percentageIntervalReached", percentage);
}
MovieBroker.prototype.percentageIntervalReached = function(percentage)
{
	if (this.tipController)
		this.tipController.shouldPercentageIntervalReached(percentage);
	else
		this.doPercentageIntervalReached(percentage);
}
MovieBroker.prototype.doAbsoluteIntervalReached = function(percentage)
{
    if (percentage == undefined)
	    this.getMessage("absoluteIntervalReached");
	else
	{
	    var percentageArray = new Array();
	    percentageArray[0] = percentage;
	    this.getMessage("absoluteIntervalReached", percentageArray);
	}
}
MovieBroker.prototype.addAbsoluteIntervalReachedHandle = function(action)
{
	this.registerAction("absoluteIntervalReached", action);
}
MovieBroker.prototype.getAbsoluteIntervalReachedAction = function(percentage)
{
	return new ObjectMethodAction(this, "absoluteIntervalReached", percentage);
}
MovieBroker.prototype.absoluteIntervalReached = function(percentage)
{
	if (this.tipController)
		this.tipController.shouldAbsoluteIntervalReached(percentage);
	else
		this.doAbsoluteIntervalReached(percentage);
}
MovieBroker.prototype.doSetTimePositionAbsolute = function(millis)
{
    if (millis == undefined)
	    this.getMessage("setTimePositionAbsolute");
	else
	{
	    var millisArray = new Array();
	    millisArray[0] = millis;
	    this.getMessage("setTimePositionAbsolute", millisArray);
	}
}
MovieBroker.prototype.addSetTimePositionAbsoluteHandle = function(action)
{
	this.registerAction("setTimePositionAbsolute", action);
}
MovieBroker.prototype.getSetTimePositionAbsoluteAction = function(millis)
{
	return new ObjectMethodAction(this, "setTimePositionAbsolute", millis);
}
MovieBroker.prototype.setTimePositionAbsolute = function(millis)
{
	if (this.tipController)
		this.tipController.shouldSetTimePositionAbsolute(millis);
	else
		this.doSetTimePositionAbsolute(millis);
}
MovieBroker.prototype.doRequestMovieForward = function()
{
	 this.getMessage("requestMovieForward");
}
MovieBroker.prototype.addRequestMovieForwardHandle = function(action)
{
	this.registerAction("requestMovieForward", action);
}
MovieBroker.prototype.getRequestMovieForwardAction = function()
{
	return new ObjectMethodAction(this, "requestMovieForward");
}
MovieBroker.prototype.requestMovieForward = function()
{
	this.doRequestMovieForward();
}
MovieBroker.prototype.doRequestMovieRewind= function()
{
    this.getMessage("requestMovieRewind");
}
MovieBroker.prototype.addRequestMovieRewindHandle = function(action)
{
	this.registerAction("requestMovieRewind", action);
}
MovieBroker.prototype.getRequestMovieRewindAction = function()
{
	return new ObjectMethodAction(this, "requestMovieRewind");
}
MovieBroker.prototype.requestMovieRewind = function(millis)
{
	this.doRequestMovieRewind();
}
