/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
ConditionEvent.prototype = new Broker();
ConditionEvent.prototype.constructor = ConditionEvent;
ConditionEvent.superclass = Broker.prototype;
function ConditionEvent(sId, condition)
{
	if (sId)
	{
		this.init(sId, condition);
	}
}
ConditionEvent.prototype.init = function(sId, condition)
{
	this.sId = sId;
	this.condition = condition;
	ConditionEvent.superclass.init.call(this, "ConditionEvent");
}
ConditionEvent.prototype.getId = function()
{
	return this.sId;
}
ConditionEvent.prototype.getSetModelAction = function()
{
	return new ObjectMethodAction(this, "setModel");
}
ConditionEvent.prototype.setModel = function(model)
{
	if (eval(model + this.condition))
	{
		var params = new Array();
		params[0] = model;
		this.getMessage("conditionFulfilled", params);
	}
}
ConditionEvent.prototype.addConditionFulfilledHandle = function(action)
{
	this.registerAction("conditionFulfilled", action);
}
