/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
RoleIntervalBroker.prototype             = new Broker();
RoleIntervalBroker.prototype.constructor = RoleIntervalBroker;
RoleIntervalBroker.superclass            = Broker.prototype;
function RoleIntervalBroker()
{
  //;
  RoleIntervalBroker.superclass.init.call(this, "RoleIntervalBroker");
}
RoleIntervalBroker.prototype.doUserTouched = function()
{
  this.getMessage("userTouched");
}
RoleIntervalBroker.prototype.addUserTouchedHandle = function(action)
{
  this.registerAction("userTouched", action);
}
RoleIntervalBroker.prototype.getUserTouchedAction = function(action)
{
  return new ObjectMethodAction(this, "userTouched");
}
RoleIntervalBroker.prototype.userTouched = function()
{
  this.doUserTouched();
}
RoleIntervalBroker.prototype.doSystemTouched = function()
{
  this.getMessage("systemTouched");
}
RoleIntervalBroker.prototype.addSystemTouchedHandle = function(action)
{
  this.registerAction("systemTouched", action);
}
RoleIntervalBroker.prototype.getSystemTouchedAction = function(action)
{
  return new ObjectMethodAction(this, "systemTouched");
}
RoleIntervalBroker.prototype.systemTouched = function()
{
  this.doSystemTouched();
}
RoleIntervalBroker.prototype.doSetInactive = function()
{
  this.getMessage("setInactive");
}
RoleIntervalBroker.prototype.addSetInactiveHandle = function(action)
{
  this.registerAction("setInactive", action);
}
RoleIntervalBroker.prototype.getSetInactiveAction = function(action)
{
  return new ObjectMethodAction(this, "setInactive");
}
RoleIntervalBroker.prototype.setInactive = function()
{
  this.doSetInactive();
}
RoleIntervalBroker.prototype.doSetActive = function()
{
  this.getMessage("setActive");
}
RoleIntervalBroker.prototype.addSetActiveHandle = function(action)
{
  this.registerAction("setActive", action);
}
RoleIntervalBroker.prototype.getSetActiveAction = function(action)
{
  return new ObjectMethodAction(this, "setActive");
}
RoleIntervalBroker.prototype.setActive = function()
{
  this.doSetActive();
}
RoleIntervalBroker.prototype.doRequestSetActive = function()
{
  this.getMessage("requestSetActive");
}
RoleIntervalBroker.prototype.addRequestSetActiveHandle = function(action)
{
  this.registerAction("requestSetActive", action);
}
RoleIntervalBroker.prototype.getRequestSetActiveAction = function(action)
{
  return new ObjectMethodAction(this, "requestSetActive");
}
RoleIntervalBroker.prototype.requestSetActive = function()
{
  this.doRequestSetActive();
}
