/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
RoleplayElementBroker.prototype             = new Broker();
RoleplayElementBroker.prototype.constructor = RoleplayElementBroker;
RoleplayElementBroker.superclass            = Broker.prototype;
function RoleplayElementBroker()
{
    ;
    this.conversationController = null;
     RoleplayElementBroker.superclass.init.call(this, "RoleplayElementBroker");
}
RoleplayElementBroker.prototype.setConversationController = function(conversationController)
{
    this.conversationController = conversationController;
}
RoleplayElementBroker.prototype.doBeginActive = function()
{
    this.getMessage("beginActive");
}
RoleplayElementBroker.prototype.addBeginActiveHandle = function(action)
{
    this.registerAction("beginActive", action);
}
RoleplayElementBroker.prototype.getBeginActiveAction = function(action)
{
    return new ObjectMethodAction(this, "beginActive");
}
RoleplayElementBroker.prototype.beginActive = function()
{
    if (this.conversationController)
        this.conversationController.shouldBeginActive();
    else
        this.doBeginActive();
}
RoleplayElementBroker.prototype.doEndActive = function()
{
    this.getMessage("endActive");
}
RoleplayElementBroker.prototype.addEndActiveHandle = function(action)
{
    this.registerAction("endActive", action);
}
RoleplayElementBroker.prototype.getEndActiveAction = function(action)
{
    return new ObjectMethodAction(this, "endActive");
}
RoleplayElementBroker.prototype.endActive = function()
{
    if (this.conversationController)
        this.conversationController.shouldEndActive();
    else
        this.doEndActive();
}
