/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function SpeechRecognizer(recognizerregistry, recognitionHandle,
  speechRecognition, keepsamples, stopafterrecognition) {
    ;
    this.recognizerregistry = recognizerregistry;
    this.recognitionHandle = recognitionHandle;
    this.speechRecognition = speechRecognition;
    this.modelURL = speechRecognition.getModelID();
    this.applicationURL = speechRecognition.getApplicationID();
    this.garbagelevel = speechRecognition.getGarbagelevel();
    this.keepsamples = keepsamples;
    this.stopafterrecognition = stopafterrecognition;
    this.recognitionBrokerArray = new Array();
    this.handle = null;
    try {
        ;
        this.handle = recognizerregistry.register(this, recognitionHandle);
    }
    catch (e) {
        ;
    }
}
SpeechRecognizer.prototype.setControlBroker = function(controlBroker)
{
  this.controlBroker = controlBroker;
  controlBroker.addRequestSoundStartHandle(this.getSoundStartAction());
  controlBroker.addRequestSoundStopHandle(this.getSoundStopAction());
  controlBroker.addRequestRecognitionStartHandle(this.getRecognitionStartAction());
  controlBroker.addRequestRecognitionStopHandle(this.getRecognitionStopAction());
}
SpeechRecognizer.prototype.getControlBroker = function()
{
	return this.controlBroker;
}
SpeechRecognizer.prototype.setRecognitionBroker = function(recognitionbroker)
{
  this.recognitionbroker = recognitionbroker;
}
SpeechRecognizer.prototype.getRecognitionBroker = function() {
  return this.recognitionbroker;
}
SpeechRecognizer.prototype.getSoundStartAction = function() {
    return new ObjectMethodAction(this, 'startPlayback');
}
SpeechRecognizer.prototype.getSoundStopAction = function() {
    return new ObjectMethodAction(this, 'stopPlayback');
}
SpeechRecognizer.prototype.getRecognitionStartAction = function() {
    return new ObjectMethodAction(this, 'startRecognition');
}
SpeechRecognizer.prototype.getRecognitionStopAction = function() {
    return new ObjectMethodAction(this, 'stopRecognition');
}
SpeechRecognizer.prototype.startPlayback = function() {
  ;
  this.handle.startPlayback();
}
SpeechRecognizer.prototype.stopPlayback = function() {
  ;
  this.handle.stopPlayback();
}
SpeechRecognizer.prototype.startRecognition = function() {
  ;
  this.handle.startRecognition();
}
SpeechRecognizer.prototype.stopRecognition = function() {
  ;
  this.handle.stopRecognition();
}
