/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>ObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
function AutoCorrectionExerciseObserver(sId, nPatience)
{
  if (sId) this.init(sId, nPatience);
}
AutoCorrectionExerciseObserver.prototype.init = function(sId, nPatience)
{
  ;
  this.sId = sId;
  this.oMarkAction = null;
  this.oMarkAndCorrectAction = null;
  this.oDoneAction = null;
  this.bCorrectionInvoked = false;
  if(nPatience)
  {
    this.nPatience = nPatience;
  }
  else
  {
    this.nPatience = 0;
  }
}
AutoCorrectionExerciseObserver.prototype.setMarkAction = function(markAction)
{
  this.oMarkAction = markAction;
}
AutoCorrectionExerciseObserver.prototype.setMarkAndCorrectAction = function(action)
{
  this.oMarkAndCorrectAction = action;
}
AutoCorrectionExerciseObserver.prototype.setDoneAction = function(action)
{
  this.oDoneAction = action;
}
AutoCorrectionExerciseObserver.prototype.statusChanged = function(status)
{
  ;
  if(!this.bCorrectionInvoked)
  {
    ;
    this.bCorrectionInvoked = true;
    if((status.nWrongStatus > 0) || (status.nCorrectStatus > 0))
    {
      if((this.nPatience == 0) || (this.nPatience < 100) && (((status.nWrongSystem + 1)/ status.nWrong) >= (this.nPatience / 100)))
      {
        ;
        if(this.oMarkAndCorrectAction)
        {
          this.oMarkAndCorrectAction.invoke();
        }
      }
      else
      {
        ;
        if(this.oMarkAction)
        {
          this.oMarkAction.invoke();
        }
      }
      if(status.nCorrect == status.nCorrectStatus)
      {
        if(this.oDoneAction)
        {
          this.oDoneAction.invoke();
        }
      }
    }
    this.bCorrectionInvoked = false;
  }
}
AutoCorrectionExerciseObserver.prototype.getExerciseStatusAction = function()
{
  return new ObjectMethodAction(this, 'statusChanged');
}
