/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function SimpleFilterManager(sId, baseURL)
{
	if (sId)
	{
		this.init(sId, baseURL);
	}
}
SimpleFilterManager.prototype.init = function(sId, baseURL)
{
	;
	this.sId = sId;
	this.baseURL = baseURL;
	this.filterController;
}
SimpleFilterManager.prototype.getId = function()
{
	return this.sId;
}
SimpleFilterManager.prototype.setFilterController = function(controller)
{
	this.controller = controller;
	this.controller.setManager(this);
}
SimpleFilterManager.prototype.processFilterCommand = function(command)
{
	
}
SimpleFilterManager.prototype.getResetFilterAction = function()
{
	return new ObjectMethodAction(this, "reset");
}
SimpleFilterManager.prototype.reset = function()
{
	this.controller.reset();
}
SimpleFilterManager.prototype.getCommitFilterAction = function()
{
	return new ObjectMethodAction(this, "commit");
}
SimpleFilterManager.prototype.commit = function()
{
	var valid = this.controller.validate();
	if (valid)
	{
		window.location.href = this.baseURL + this.controller.getFilterCommand();
	}
}
