/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function BooleanSelectionWidget(sId)
{
	if (sId)
	{
		this.init(sId);
	}
}
BooleanSelectionWidget.prototype.init = function(sId)
{
	this.sId = sId;
	this.model = null;
	this.selectedHandles = new Array();
	this.unselectedHandles = new Array();
}
BooleanSelectionWidget.prototype.start = function()
{
	this.selectionModelChanged(this.model);
}
BooleanSelectionWidget.prototype.getId = function()
{
	return this.sId;
}
BooleanSelectionWidget.prototype.setSelectionModel = function(model)
{
	this.model = model;
}
BooleanSelectionWidget.prototype.setBroker = function(broker)
{
	this.broker = broker;
	broker.setManager(this);
}
BooleanSelectionWidget.prototype.selectionModelChanged = function(model)
{
	var sv = model.getSelectionValueByIndex(1);
	if (sv.isActive() == true)
		this.broker.doSelected();
	else
		this.broker.doUnSelected();
}
BooleanSelectionWidget.prototype.setSelected = function(selected)
{
	if (selected)
	{
		this.model.getSelectionValueByIndex(1).setActive(true);
	}
	else
	{
		this.model.getSelectionValueByIndex(0).setActive(true);
	}
}
